/**
 * @file
 * VuoList_VuoAudioBinAverageType C type definition.
 *
 * @copyright Copyright © 2012–2015 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoAudioBinAverageType_H
#define VuoList_VuoAudioBinAverageType_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoAudioBinAverageType VuoList_VuoAudioBinAverageType
 * A list of @ref VuoAudioBinAverageType elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoAudioBinAverageType_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoAudioBinAverageType elements.
 */
typedef const struct VuoList_VuoAudioBinAverageType_struct { void *l; } * VuoList_VuoAudioBinAverageType;
/// @}
#endif

/**
 * Creates a new list of @ref VuoAudioBinAverageType elements.
 */
VuoList_VuoAudioBinAverageType VuoListCreate_VuoAudioBinAverageType(void);

/**
 * Makes a shallow copy of `list` — its items are retained (not copied) by the new list.
 */
VuoList_VuoAudioBinAverageType VuoListCopy_VuoAudioBinAverageType(const VuoList_VuoAudioBinAverageType list);

/**
 * Returns the @ref VuoAudioBinAverageType at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoAudioBinAverageType VuoListGetValue_VuoAudioBinAverageType(const VuoList_VuoAudioBinAverageType list, const unsigned long index);

/**
 * Changes the @ref VuoAudioBinAverageType at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValue_VuoAudioBinAverageType(const VuoList_VuoAudioBinAverageType list, const VuoAudioBinAverageType value, const unsigned long index);

/**
 * Inserts the `VuoAudioBinAverageType` immediately before `index`.
 * Index values start at 1.
 * Inserting at index 0 prepends the value to the list.
 * Inserting at an index beyond the last value in the list appends the value to the list.
 */
void VuoListInsertValue_VuoAudioBinAverageType(const VuoList_VuoAudioBinAverageType list, const VuoAudioBinAverageType value, const unsigned long index);

/**
 * Prepends @c value to @c list.
 */
void VuoListPrependValue_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list, const VuoAudioBinAverageType value);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list, const VuoAudioBinAverageType value);

/**
 * Swaps the value at `indexA` with the value at `indexB`.
 */
void VuoListExchangeValues_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list, const unsigned long indexA, const unsigned long indexB);

/**
 * Generates a random permutation of `list`.
 *
 * `chaos` ranges from 0 to 1.  When `chaos` is 1, a full Fisher–Yates shuffle is performed.  When less than 1, fewer iterations are performed.
 */
void VuoListShuffle_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list, const double chaos);

/**
 * Reverses the order of the items in `list`.
 */
void VuoListReverse_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list);

/**
 * Removes items from the list except those in the range specified by `startIndex` and `itemCount`.
 */
void VuoListCut_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list, const signed long startIndex, const unsigned long itemCount);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list);

/**
 * Removes the `VuoAudioBinAverageType` at `index`.
 * Index values start at 1.
 * Attempting to remove index 0 or an index beyond the last value in the list has no effect.
 */
void VuoListRemoveValue_VuoAudioBinAverageType(VuoList_VuoAudioBinAverageType list, const unsigned long index);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoAudioBinAverageType(const VuoList_VuoAudioBinAverageType list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoAudioBinAverageType VuoList_VuoAudioBinAverageType_makeFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoAudioBinAverageType_getJson(const VuoList_VuoAudioBinAverageType value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoAudioBinAverageType_getSummary(const VuoList_VuoAudioBinAverageType value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoAudioBinAverageType VuoList_VuoAudioBinAverageType_makeFromString(const char *str);
char * VuoList_VuoAudioBinAverageType_getString(const VuoList_VuoAudioBinAverageType value);
/// @}

/**
 * @}
 */

#endif
